/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.payment.action;

import java.util.Date;
import java.util.Iterator;
import java.util.List;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.human.dao.MKihonDao;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.dao.PaymentListDao;
import jp.mosp.payroll.dao.PhPaymentDao;
import jp.mosp.payroll.dto.PaymentListDto;
import jp.mosp.payroll.payment.vo.PaymentListVo;

/**
 * 給与データ一覧画面における処理を行う。<br><br>
 * 以下のコマンドを扱う。
 * <ul><li>
 * {@link #CMD_SHOW}
 * </li><li>
 * {@link #CMD_SEARCH}
 * </li><li>
 * {@link #CMD_RE_SEARCH}
 * </li><li>
 * {@link #CMD_SORT}
 * </li><li>
 * {@link #CMD_PAGE}
 * </li></ul>
 */
public class PaymentListAction extends PayrollAction {
	
	/**
	 * 画面表示コマンド。<br><br>
	 * 給与計算中の年月を取得、表示する。<br>
	 * もし給与計算中の年月がなかった場合は、システム年月を表示する。<br>
	 */
	public static final String CMD_SHOW = "P1240";
	
	/**
	 * 検索コマンド。<br><br>
	 * 指定された条件で給与データの検索を行い、一覧表示する。<br>
	 */
	public static final String CMD_SEARCH = "P1241";
	
	/**
	 * 再検索コマンド。<br><br>
	 * 保存された条件で給与データの検索を行い、一覧表示する。<br>
	 */
	public static final String CMD_RE_SEARCH = "P1242";
	
	/**
	 * ソートコマンド。<br><br>
	 * 指定された条件で給与データの並べ替えを行い、一覧表示する。<br>
	 */
	public static final String CMD_SORT = "P1243";
	
	/**
	 * ページコマンド。<br><br>
	 * 指定された条件で給与データのページ繰りを行い、一覧表示する。<br>
	 */
	public static final String CMD_PAGE = "P1244";
	
	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public PaymentListAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new PaymentListVo();
	}
	
	/**
	 * アクション。<br>
	 * 詳細は、クラス説明を参照。<br>
	 */
	public void action() throws Exception {
		// VO取得及び設定
		prepareVo();
		if (this.cmd.equals(CMD_SHOW)) {
			// 画面表示
			show();
		} else if (this.cmd.equals(CMD_SEARCH)) {
			// 検索処理
			search();
		} else if (this.cmd.equals(CMD_RE_SEARCH)) {
			// 再検索処理
			reSearch();
		} else if (this.cmd.equals(CMD_SORT)) {
			// ソート処理
			sort();
		} else if (this.cmd.equals(CMD_PAGE)) {
			// ページ処理
			page();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 画面表示処理を行う。<br><br>
	 * @throws Exception 
	 */
	private void show() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		PaymentListVo vo = (PaymentListVo)getVo();
		// システム日付取得
		Date sysDate = new Date();
		// プルダウンアイテム設定
		vo.setPitYear(getYearArray(
				PayrollConst.DEFAULT_CURRENT_YEAR, MospUtility.getYear(sysDate) + 1));
		vo.setPitMonth(getMonthArray());
		vo.setPitOffice  (getOfficeArray());
		vo.setPitSection (getSectionArrayAll());
		vo.setPitPosition(getPositionArrayAll());
		// 計算中情報取得
		Date current = getCurrent(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT);
		// 計算中情報確認
		if (current == null) {
			// VOフィールド設定
			vo.setPltYear (MospUtility.getYear (sysDate));
			vo.setPltMonth(MospUtility.getMonth(sysDate));
			return;
		}
		// VOフィールド設定
		vo.setTxtKCode("");
		vo.setTxtKKana("");
		vo.setPltYear (MospUtility.getYear (current));
		vo.setPltMonth(MospUtility.getMonth(current));
		// リスト取得
		getList();
	}
	
	/**
	 * 検索処理を行う。
	 * @throws Exception 
	 */
	private void search() throws Exception {
		// VO取得
		PaymentListVo vo = (PaymentListVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// リスト取得
		getList();
	}
	
	/**
	 * 	再検索処理を行う。
	 * @throws Exception 
	 */
	private void reSearch() throws Exception {
		// リスト取得
		getList();
	}
	
	/**
	 * ソート処理を行う。
	 * @throws Exception 
	 */
	private void sort() throws Exception {
		// VO取得
		PaymentListVo vo = (PaymentListVo)getVo();
		// ソート情報設定
		vo.setSortKey(key1);
		vo.setSelectIndex(1);
		// リスト取得
		getList();
	}
	
	/**
	 * ページ処理を行う。
	 * @throws Exception 
	 */
	private void page() throws Exception {
		// VO取得
		PaymentListVo vo = (PaymentListVo)getVo();
		// ページ情報設定
		vo.setSelectIndex(Integer.parseInt(key1));
		// リスト取得
		getList();
	}
	
	/**
	 * リストを取得する。
	 * @throws Exception 
	 */
	private void getList() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		PaymentListVo vo = (PaymentListVo)getVo();
		// 対象年月取得
		Date targetMonth = getDate(vo.getPltYear(), vo.getPltMonth(), PayrollConst.TIME_DEFAULT_DAY);
		vo.setLblTargetMonth(MospUtility.getDateString(targetMonth, PayrollConst.FORMAT_DATE));
		// DAO準備
		PaymentListDao dao = new PaymentListDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.countForPaymentList(
				vo.getTxtKCode   (),
				vo.getTxtKKana   (),
				vo.getPltOffice  (),
				vo.getPltSection (),
				vo.getPltPosition(),
				targetMonth
		));
		// 検索
		List<PaymentListDto> list = dao.findForPaymentList(
				vo.getTxtKCode   (),
				vo.getTxtKKana   (),
				vo.getPltOffice  (),
				vo.getPltSection (),
				vo.getPltPosition(),
				targetMonth        ,
				getSortKey       (),
				vo.getIsAscending(),
				vo.getDataPerPage(),
				vo.getOffset     ()
		);
		// 名称取得用配列取得
		String[][] aryOffice   = getOfficeArrayAll  ();
		String[][] arySection  = getSectionArrayAll ();
		String[][] aryPosition = getPositionArrayAll();
		// コード変換
		for (Iterator<PaymentListDto> it = list.iterator(); it.hasNext();) {
			PaymentListDto dto = it.next();
			dto.setOfficeName  (getCodeName(dto.getJCode(), aryOffice  ));
			dto.setSectionName (getCodeName(dto.getSCode(), arySection ));
			dto.setPositionName(getCodeName(dto.getYCode(), aryPosition));
		}
		// VOに設定
		vo.setFields(list);
		// 対象が無かった場合のメッセージ設定
		if (vo.getCount() == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
	}
	
	/**
	 * ソートキーを取得する。<br>
	 * @return ソートキー
	 */
	private String getSortKey() {
		// VO取得
		PaymentListVo vo = (PaymentListVo)getVo();
		// 選択キー取得
		String selectKey = vo.getSelectKey();
		// ソートキー取得
		String sortKey = PhPaymentDao.TABLE + "." + PhPaymentDao.COL_KCODE;
		if (selectKey == null) {
			// 処理無し
		} else if (selectKey.equals("2")) {
			sortKey = MKihonDao.COL_FURIGANA;
		} else if (selectKey.equals("3")) {
			sortKey = MKihonDao.COL_JCODE;
		} else if (selectKey.equals("4")) {
			sortKey = MKihonDao.COL_SCODE;
		} else if (selectKey.equals("5")) {
			sortKey = MKihonDao.COL_YCODE;
		} else if (selectKey.equals("6")) {
			sortKey = PhPaymentDao.COL_PAYMENT_TOTAL;
		}
		return sortKey;
	}
	
}
